=== modified file 'NEWS'
--- NEWS	2008-04-17 05:49:53 +0000
+++ NEWS	2008-04-17 15:53:59 +0000
@@ -27,8 +27,11 @@
       update. (John Arbash Meinel, #213771)
 
     * Severe performance degradation in fetching from knit repositories to
-      packs due to parsing the entire revisions.kndx on every graph walk
-      iteration fixed by using the Repository.get_graph API. (Robert Collins)
+      knits and packs due to parsing the entire revisions.kndx on every graph
+      walk iteration fixed by using the Repository.get_graph API.  There was
+      another regression in knit => knit fetching which re-read the index for
+      every revision each side had in common.
+      (Robert Collins, John Arbash Meinel)
 
   DOCUMENTATION:
 

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2008-04-14 22:39:51 +0000
+++ bzrlib/repository.py	2008-04-16 14:54:19 +0000
@@ -592,10 +592,10 @@
         Returns a set of the present revisions.
         """
         result = []
-        for id in revision_ids:
-            if self.has_revision(id):
-               result.append(id)
-        return result
+        graph = self.get_graph()
+        parent_map = graph.get_parent_map(revision_ids)
+        # The old API returned a list, should this actually be a set?
+        return parent_map.keys()
 
     @staticmethod
     def create(a_bzrdir):

